SystemOrganization addCategory: #Familiar!
SystemOrganization addCategory: #'Familiar-SPINE'!
SystemOrganization addCategory: #'Familiar-Core'!
SystemOrganization addCategory: #'Familiar-Tests'!
SystemOrganization addCategory: #'Familiar-Moose'!
SystemOrganization addCategory: #'Familiar-Visitor'!
SystemOrganization addCategory: #'Familiar-SPINE-Tests'!

MooseGroup subclass: #FMAssignmentGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMAssignmentGroup commentStamp: '<historical>' prior: 0!
MooseModel resetMeta!

!FMAssignmentGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 15:44'!
annotation

	<MSEClass: #AssignmentGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMAssignmentGroup methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:12'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>
	
	"Preambule. It includes the initialization. "
	| view assignments |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"
	self viewComplexityOn: view.
	"-------------"
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

!FMAssignmentGroup methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:15'!
viewComplexityOn: view

"	(assignments anySatisfy:  [ :ass | ass featureModel numberOfConstraints > 0])
		ifTrue: 
			[ view shape rectangle 
				linearFillColor: [ :ass | ass featureModel numberOfConstraints] within: assignments ]."
	
	 self do: [:ass | ass viewComplexityOn: view ].
! !

MooseGroup subclass: #FMFeatureGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMFeatureGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 14:29'!
annotation

	<MSEClass: #FeatureGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMFeatureGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/2/2012 14:59'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>

	"Preambule. It includes the initialization. "
	| view nodes |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"

	nodes := self asArray.
	view interaction action: #inspect; popupText.

	view nodes: nodes.
	view edges: nodes from: #yourself toAll:  #subFeatures.
	view treeLayout.
	"-------------" 
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

MooseGroup subclass: #FMFeatureModelGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMFeatureModelGroup class methodsFor: 'instance creation' stamp: 'AlexandreBergel 7/2/2012 01:12'!
annotation

	<MSEClass: #FeatureModelGroup super: #MooseGroup>
	<package: #Familiar>
! !

!FMFeatureModelGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 16:58'!
setInteractionOfNodes: view
	view interaction 
			popupText: #description.! !

!FMFeatureModelGroup methodsFor: 'visualization' stamp: 'AlexandreBergel 7/3/2012 13:24'!
viewDistribution
	<menuItem: 'Distribution' category: 'Visualize'>
	
	| view | 
	view := MOViewRenderer new.
	view shape rectangle 
			width: [ :fm | fm numberOfProductions * 5 ];
			height: [ :fm | fm numberOfConstraints * 5 ].
	
	self setInteractionOfNodes: view.
	view nodes: self entities.
	^ view openWithStatusbar title: 'Class Blueprint'! !

MooseEntity subclass: #FMObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMObject subclass: #FMConstraintExpr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMConstraintExpr subclass: #FMConstraintBinOp
	instanceVariableNames: 'left right'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMConstraintBinOp subclass: #FMConstraintAnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintAnd class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '&'! !

!FMConstraintAnd class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	^ 'and'! !

!FMConstraintAnd methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintAnd: self.
	super accept: aVisitor! !

FMConstraintBinOp subclass: #FMConstraintArrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintArrow class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '->'! !

!FMConstraintArrow methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:40'!
accept: aVisitor
	aVisitor visitConstraintArrow: self.
	super accept: aVisitor! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:26'!
for: string
	"Return the class that correspond to the string. 
	We here assume that all the subclasses have a distint operator"
	^ self allSubclasses detect: [:cls | (cls operator = string) or: [ cls operator2 = string ] ]! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 10:00'!
operator
	^ self subclassResponsibility ! !

!FMConstraintBinOp class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	"Express the alternative of operator, for example or | and and &"
	^ self operator! !

!FMConstraintBinOp methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor

	left accept: aVisitor.
	right accept: aVisitor.! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:21'!
features
	"Return the list of features that are recursively obtained from myself"
	
	| v |
	v := CollectingVisitor new.
	self accept: v.
	^ v elementsOfKind: FMFeature ! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:01'!
left
	^ left! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:01'!
left: anObject
	left := anObject! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:02'!
right
	^ right! !

!FMConstraintBinOp methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:02'!
right: anObject
	right := anObject! !

FMConstraintBinOp subclass: #FMConstraintEquiv
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintEquiv class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '<->'! !

!FMConstraintEquiv methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintEquiv: self.
	super accept: aVisitor! !

FMConstraintBinOp subclass: #FMConstraintPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintPipe class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/1/2012 09:59'!
operator
	^ '|'! !

!FMConstraintPipe class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 17:25'!
operator2
	^ 'or'! !

!FMConstraintPipe methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintPipe: self.
	super accept: aVisitor! !

!FMConstraintExpr methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 13:27'!
accept: aVisitor
	self subclassResponsibility ! !

FMConstraintExpr subclass: #FMConstraintNegated
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMConstraintNegated methodsFor: 'visiting' stamp: 'AlexandreBergel 7/3/2012 14:41'!
accept: aVisitor
	aVisitor visitConstraintNegated: self.
	expr accept: aVisitor! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:05'!
expr
	^ expr! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:05'!
expr: anObject
	expr := anObject! !

!FMConstraintNegated methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:23'!
features
	^ expr features! !

FMObject subclass: #FMFeature
	instanceVariableNames: 'name featureModel kind constraintsCache subFeaturesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeature class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/2/2012 11:01'!
named: aName
	^ self new name: aName; yourself! !

!FMFeature methodsFor: 'equality' stamp: 'AlexandreBergel 7/2/2012 11:00'!
= aFeature
	^ self name = aFeature name! !

!FMFeature methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:13'!
accept: aVisitor 
	aVisitor visitFeature: self! !

!FMFeature methodsFor: 'navigating' stamp: 'AlexandreBergel 7/4/2012 14:37'!
constrainedFeatures
	<navigation: 'constrained features'>
	^ ((self constraints inject: #() into: [ :sum :c | sum , c features ]) asSet asArray) copyWithout: self! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:11'!
constraints
	"Return the list of constraints in which I am involved"
	
	constraintsCache ifNotNil: [ ^ constraintsCache ].
	^ constraintsCache := featureModel constraintsContainingFeature: self! !

!FMFeature methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 13:32'!
constraintsInfo
	| str |
	
	str := WriteStream on: String new.
	(self impliedBy copyFrom: 1 to: (self impliedBy size min: 5)) do: [ :f | 
		str nextPutAll: String cr.
		str nextPutAll: f name, ' -> '
		].
	(self impliedBy size > 5) ifTrue: [ 
		str nextPutAll: String cr.
		str nextPutAll: '... (', self impliedBy size printString, ')'		
	].

	(self implying copyFrom: 1 to: (self implying size min: 5))  do: [ :f | 
		str nextPutAll: String cr.
		str nextPutAll:  ' -> ', f name
		].
	(self implying size > 5) ifTrue: [ 
		str nextPutAll: String cr.
		str nextPutAll: '... (', self implying size printString, ')'	
	].
	^ str contents! !

!FMFeature methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 17:03'!
description

	| v |
	self isOr ifTrue: [ v := ' or' ].
	self isXor ifTrue: [ v := ' xor' ].
	self isMandatory ifTrue: [ v := ' mendatory' ].
	self isMutex ifTrue: [ v := ' mutex' ].
	self isOptional ifTrue: [ v := ' optional' ].	 

	^ ' Feature ', self name, v, self constraintsInfo! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 16:40'!
exclusions
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v exclusions! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:11'!
featureModel
	"Return the feature model that defines me"
	
	^ featureModel! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:25'!
featureModel: fm
	featureModel := fm! !

!FMFeature methodsFor: 'equality' stamp: 'AlexandreBergel 7/2/2012 11:00'!
hash
	^ self name hash! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/4/2012 17:27'!
impliedBy
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v featuresImplied! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/4/2012 17:27'!
implying
	| v |
	v := FMCollectingFeatureVisitor new.
	v focusedFeature: self.
	self featureModel accept: v.
	^ v featuresImplying! !

!FMFeature methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/3/2012 17:14'!
initialize 
	"We say that per default, a feature is mendatory. Actually, the kind variable is always set"

	super initialize.
	kind := FMFeatureMendatory new! !

!FMFeature methodsFor: 'visiting' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory
	^ kind isMandatory! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isMutex
	^ kind isMutex! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isOptional
	^ kind isOptional! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isOr
	^ kind isOr! !

!FMFeature methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:11'!
isXor
	^ kind isXor! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
kind
	"return the instance of FMFeatureExpr that says whether I am mendatory, mutex, or, xor, or optional"

	^ kind! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 18:10'!
kind: anObject
	kind := anObject! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
name
	"My name"
	^ name! !

!FMFeature methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:12'!
name: aString
	"My name"
	name := aString! !

!FMFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 7/3/2012 17:14'!
numberOfConstraints
	"Return the number of constraints in which I am involved"
	
	^ self constraints size! !

!FMFeature methodsFor: 'metrics' stamp: 'AlexandreBergel 7/6/2012 17:34'!
numberOfExclusions 
	^ self exclusions size! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 11:45'!
numberOfFeaturesImpliedBy
	^ self impliedBy size
! !

!FMFeature methodsFor: 'accessing - constraints' stamp: 'AlexandreBergel 7/6/2012 11:42'!
numberOfFeaturesImplying
	^ self implying size! !

!FMFeature methodsFor: 'navigating' stamp: 'AlexandreBergel 7/3/2012 14:14'!
subFeatures
	<navigation: 'sub features'>
	subFeaturesCache ifNotNil: [ ^ subFeaturesCache ].
  
	^ subFeaturesCache := featureModel subFeaturesOf: self! !

FMObject subclass: #FMFeatureExpr
	instanceVariableNames: 'feature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureExpr methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:15'!
accept: aVisitor
	feature accept: aVisitor
	! !

!FMFeatureExpr methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 10:57'!
feature
	^ feature! !

!FMFeatureExpr methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 18:10'!
feature: aFeature
	feature := aFeature.
	aFeature kind: self.! !

!FMFeatureExpr methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isMutex
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isOptional
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isOr
	^ false! !

!FMFeatureExpr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isXor
	^ false! !

!FMFeatureExpr methodsFor: 'printing' stamp: 'AlexandreBergel 7/1/2012 10:45'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	id ifNotNil: [ str nextPutAll: id ].
	str nextPut: $>.! !

FMFeatureExpr subclass: #FMFeatureMendatory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureMendatory methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 7/6/2012 17:03'!
isMandatory 
	^ true! !

FMFeatureExpr subclass: #FMFeatureMutex
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureMutex methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:12'!
isMutex 
	^ true! !

FMFeatureExpr subclass: #FMFeatureOptional
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureOptional methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isOptional 
	^ true! !

FMFeatureExpr subclass: #FMFeatureOr
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureOr methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isOr
	^ true! !

FMFeatureExpr subclass: #FMFeatureXor
	instanceVariableNames: 'expr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureXor methodsFor: 'testing' stamp: 'AlexandreBergel 7/2/2012 18:13'!
isXor
	^ true! !

FMObject subclass: #FMFeatureModel
	instanceVariableNames: 'exprs constraints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureModel methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 10:45'!
accept: aVisitor 
	aVisitor visitFeatureModel: self.
	exprs do: [ :expr | expr accept: aVisitor ]. 
	constraints do: [ :cons | cons accept: aVisitor ].! !

!FMFeatureModel methodsFor: 'adding' stamp: 'AlexandreBergel 7/2/2012 13:25'!
addAllConstraints: cons
	self assert: [ cons isCollection ].
	self assert: [ cons isEmpty or: [ cons first isKindOf: FMConstraintExpr ] ].
	constraints addAll: cons! !

!FMFeatureModel methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 15:22'!
addAllExpressions: exps
	exprs addAll: exps! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 14:50'!
constraintAt: index
	^ constraints at: index! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 17:22'!
constraintsContainingFeature: aFeature
	
	| v |
	^ self constraintsSelect: [ :cons | 
		cons features includes: aFeature ]! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 15:00'!
constraintsInfo
	^ ''! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 14:34'!
constraintsSelect: aBlock
	^ constraints select: aBlock! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:44'!
featureNamed: aName 
	^ self features detect: [ :f | f name = aName ]! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:28'!
features
	| v |
	v := CountingFeatureVisitor new.
	self accept: v.
	v features do: [ :f | f featureModel: self ].
	^ v features! !

!FMFeatureModel methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 14:26'!
initialize 
	super initialize.
	exprs := OrderedCollection new.
	constraints := OrderedCollection new! !

!FMFeatureModel methodsFor: 'printing' stamp: 'AlexandreBergel 7/2/2012 14:15'!
mooseNameOn: str 

	str nextPutAll: 'FM ('.
	exprs
		do: [ :expr | str nextPutAll: expr root name ].
	str nextPutAll: ')'.
	^ str contents! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:59'!
numberOfConstraints
	<MSEProperty: #numberOfConstraints type: #Number>
	^ constraints size! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 10:41'!
numberOfFeatures
	^ self features size! !

!FMFeatureModel methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:59'!
numberOfProductions
	<MSEProperty: #numberOfProductions type: #Number>
	^ exprs size! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 14:50'!
productionAt: index
	^ exprs at: index! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:49'!
setInteractionOfFeature: view
	view interaction 
			popupText: #description;
	
			item: 'constrained features' action: [ :f | f constrainedFeatures inspect ];
			item: 'inspect' action: #inspect;
			item: 'implications' action: [ :e | self visualizeImplications ];
						
			highlightWhenOver: #implying color: Color lightBlue;
			highlightWhenOver: #impliedBy color: Color blue;
			highlightWhenOver: #exclusions color: Color red.
			"highlightWhenOver: #constrainedFeatures color: Color green"! !

!FMFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:45'!
subFeaturesOf: aFMFeature 
	^ ((exprs detect: [ :prod | prod root = aFMFeature ] ifNone: [ ^ #() ] ) allChildren collect: #feature) asArray! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:46'!
viewComplexityOn: view

	view node: self forIt: [		
		view shape rectangle 
			"size:  [ :f | f numberOfConstraints * 3 ];"
			height: [ :f | f numberOfFeaturesImplying * 3 ];
			width: [ :f | f numberOfFeaturesImpliedBy * 3 ]; 
			borderWidth: [ :f |  f numberOfExclusions max: 1 ];
			if: #isMandatory fillColor: Color white;
			if: #isOr fillColor: Color pink;
			if: #isMutex fillColor: Color lightYellow;
			if: #isOptional fillColor: Color lightGray;
			if: #isXor fillColor: Color yellow.
		self setInteractionOfFeature: view.
		view nodes: self features.
					
		view edges: self features from: #yourself toAll: #subFeatures.
		view treeLayout ].
	! !

!FMFeatureModel methodsFor: 'visualization' stamp: 'AlexandreBergel 7/6/2012 17:46'!
visualizeImplications
	| view |
	view := ROMondrianViewBuilder new.
	
	view shape rectangle 
			"size:  [ :f | f numberOfConstraints * 3 ];"
			height: [ :f | f numberOfFeaturesImplying * 3 ];
			width: [ :f | f numberOfFeaturesImpliedBy * 3 ]; 
			borderWidth: [ :f |  f numberOfExclusions max: 1 ];
			if: #isMandatory fillColor: Color white;
			if: #isOr fillColor: Color pink;
			if: #isMutex fillColor: Color lightYellow;
			if: #isOptional fillColor: Color lightGray;
			if: #isXor fillColor: Color yellow.
			
	view nodes: self features.
	
	view shape arrowedLineWithOffset: 0.3; color: Color green.
	view edges: self features from: #yourself toAll: #implying.

	view shape line color: Color red.
	view edges: self features from: #yourself toAll: #exclusions.

	view circleLayout .
	view open! !

FMObject subclass: #FMFeatureProduction
	instanceVariableNames: 'root children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMFeatureProduction methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 10:50'!
accept: aVisitor
	root accept: aVisitor.
	children do: [ :child | child accept: aVisitor ] ! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:32'!
addAll: featureExpressions
	self assert: [ featureExpressions isCollection ].

	children addAll: featureExpressions! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:43'!
allChildren
	^ children copy! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:37'!
childAt: index
	^ children at: index! !

!FMFeatureProduction methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 10:32'!
initialize
	super initialize.
	children := OrderedCollection new! !

!FMFeatureProduction methodsFor: 'metrics' stamp: 'AlexandreBergel 7/1/2012 10:37'!
numberOfChildren
	^ children size! !

!FMFeatureProduction methodsFor: 'printing' stamp: 'AlexandreBergel 7/1/2012 15:23'!
printOn: str
	super printOn: str.
	str nextPut: $<.
	id ifNotNil: [ str nextPutAll: root ].
	str nextPut: $>.! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:31'!
root
	^ root! !

!FMFeatureProduction methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 10:31'!
root: anObject
	root := anObject! !

FMObject subclass: #FMProgram
	instanceVariableNames: 'statements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMProgram methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:03'!
accept: aVisitor
	aVisitor visitProgram: self.
	self statements do: [ :s | s accept: aVisitor ]! !

!FMProgram methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 14:57'!
add: aStatement
	statements add: aStatement ! !

!FMProgram methodsFor: 'adding' stamp: 'AlexandreBergel 7/1/2012 15:06'!
addAll: ss
	ss do: [ :s | self add: s ]! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 15:09'!
featureNamed: aName
	| v t |
	v := CollectingVisitor new.
	self accept: v.
	t := (v elementsOfKind: FMFeature) select: [ :f | f name = aName ] .
	self assert: [ t size =  1 ].
	^ t first! !

!FMProgram methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/1/2012 14:57'!
initialize
	super initialize.
	statements := OrderedCollection new! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 16:24'!
lastStatement 
	^ statements last! !

!FMProgram methodsFor: 'metrics' stamp: 'AlexandreBergel 7/2/2012 00:58'!
numberOfStatements
	<MSEProperty: #numberOfStatements type: #Number>
	^ statements size! !

!FMProgram methodsFor: 'metrics' stamp: 'AlexandreBergel 7/3/2012 16:56'!
numberOfVariables
	^ (self statements collect: #variable) asSet size! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:08'!
statementAt: index
	^ statements at: index! !

!FMProgram methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 00:14'!
statements
	^ statements copy! !

FMObject subclass: #FMStatement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

FMStatement subclass: #FMAssignment
	instanceVariableNames: 'variable featureModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Core'!

!FMAssignment methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:16'!
accept: aVisitor
	aVisitor visitAssigment: self.
	
	aVisitor visitVariable: variable.
	featureModel accept: aVisitor.! !

!FMAssignment methodsFor: 'navigating' stamp: 'AlexandreBergel 7/2/2012 00:57'!
featureModel
	<navigation: 'Feature model'>
	^ featureModel! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
featureModel: anObject
	featureModel := anObject! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 11:35'!
mooseFinderComplexityIn: composite
	<moosePresentationOrder: 20>
	
	composite roassal 
			title: 'Complexity';
			titleIcon: MooseIcons mooseBlueprint;
			painting: [ :view :each | each mooseInterestingEntity viewComplexityOn: view ]! !

!FMAssignment methodsFor: 'printing' stamp: 'AlexandreBergel 7/2/2012 00:49'!
mooseNameOn: str
	str nextPutAll: variable! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 16:59'!
setInteractionOfNodes: view
	view interaction 
			popupText: #description;

			item: 'constrained features' action: [ :f | f constrainedFeatures inspect ];
			highlightWhenOver: #impliedBy color: Color green! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
variable
	^ variable! !

!FMAssignment methodsFor: 'accessing' stamp: 'AlexandreBergel 7/1/2012 15:01'!
variable: anObject
	variable := anObject! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/3/2012 16:14'!
viewComplexity
	<menuItem: 'Complexity' category: 'Visualize'>

	"Preambule. It includes the initialization. "
	| view assignments |
	view := ROMondrianViewBuilder new.
	"enter your script below"
	"-------------"
	"-------------"
	self viewComplexityOn: view.
	"-------------"
	"-------------"
	"Below is the initiation of the menu and opening the visualization"
	ROEaselMorphic new populateMenuOn: view.
	view open! !

!FMAssignment methodsFor: 'visualizing' stamp: 'AlexandreBergel 7/6/2012 11:39'!
viewComplexityOn: view
	| fm |

	view interaction popupText: self variable; action: #inspect.
	featureModel viewComplexityOn: view.
! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 15:44'!
allAssignments
	<navigation: 'All assigment'>
	^ FMAssignmentGroup 
		withAll: (self allWithType: FMAssignment )
		withDescription: 'Assignment'
	! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 01:05'!
allFeatureModels
	<navigation: 'All feature models'>
	^ FMFeatureModelGroup 
		withAll: (self allWithType: FMFeatureModel )
		withDescription: 'Feature models'
	! !

!MooseModel methodsFor: '*familiar-core' stamp: 'AlexandreBergel 7/2/2012 14:29'!
allFeatures
	<navigation: 'All features'>
	^ FMFeatureGroup 
		withAll: (self allWithType: FMFeature )
		withDescription: 'Features'
	! !

TestCase subclass: #FMTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

FMTest subclass: #FMFeatureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 15:10'!
testConstraints1

	| fm c d |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> D ; )'.

	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: (fm constraintsContainingFeature: c) = c constraints.
	self assert: c constraints size = 1.
	
	self assert: (fm constraintsContainingFeature: d) = d constraints.
	self assert: d constraints size = 1.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
testConstraints2

	| fm c d |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C <-> D ; )'.

	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: (fm constraintsContainingFeature: c) = c constraints.
	self assert: c constraints size = 1.
	
	self assert: (fm constraintsContainingFeature: d) = d constraints.
	self assert: d constraints size = 1.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/3/2012 17:02'!
testConstraints3

	| fm c d a b |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | ( D | !!E) ) ;  (C | A); C & D;)'.

	a := fm featureNamed: 'A'.
	b := fm featureNamed: 'B'.
	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	
	self assert: c numberOfConstraints = 3.
	self assert: d numberOfConstraints = 2.
	self assert: a numberOfConstraints = 1.
	self assert: b numberOfConstraints = 0.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 10:54'!
testConstraints4

	| fm c d a b e cons |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | ( D | !!(E & A) ) ) ; )'.

	a := fm featureNamed: 'A'.
	b := fm featureNamed: 'B'.
	c := fm featureNamed: 'C'.
	d := fm featureNamed: 'D'.
	e := fm featureNamed: 'E'.
	
	self assert: a constraints size = 1.
	
	cons := a constraints first.
	self assert:  (cons features includesAllOf: {c . e . a . d}).
	self assert:  ({c . e . a . d} includesAllOf: cons features).
	
	self assert: (a constrainedFeatures includesAllOf: {c .d .e}).
	self assert: ({c .d .e} includesAllOf: a constrainedFeatures).
	self assert: (b constrainedFeatures isEmpty).! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 10:59'!
testEquality

	| fm1 fm2 fm3 |
	fm1 := FMFeature new name: 'A'.
	fm2 := FMFeature new name: 'A'.
	fm3 := FMFeature new name: 'AA'.
	self assert: fm1 = fm2.
	self assert: fm1 ~~ fm2.
	
	self assert: fm1 ~= fm3.
	self assert: fm1 ~~ fm3.! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/3/2012 17:13'!
testEquality2

	self deny: FMFeature new = Object new.
	self deny: (FMFeature named: 'foo') = 'foo'.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:26'!
testExclusion1
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> D ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.
	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'D' }.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:38'!
testExclusion2
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; C -> (D | E) ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.

	self assert: (fm featureNamed: 'E') impliedBy = { fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'E') implying isEmpty.

	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/4/2012 17:38'!
testExclusion3
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; (C | Z) -> (D | E) ; )'.
	
	self assert: (fm featureNamed: 'D') impliedBy = { fm featureNamed: 'Z' .  fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'D') implying isEmpty.

	self assert: (fm featureNamed: 'E') impliedBy = { fm featureNamed: 'Z' .  fm featureNamed: 'C' }.
	self assert: (fm featureNamed: 'E') implying isEmpty.

	
	self assert: (fm featureNamed: 'C') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.

	self assert: (fm featureNamed: 'Z') implying = { fm featureNamed: 'E' . fm featureNamed: 'D'}.
	self assert: (fm featureNamed: 'Z') impliedBy isEmpty.! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:32'!
testExclusion4
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; A -> !! B ; )'.
	
	self deny: (fm featureNamed: 'B') impliedBy = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'B') exclusions = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'A') exclusions = { fm featureNamed: 'B' }! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:12'!
testExclusion5
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ;  !!A -> B ; )'.
	
	self assert: (fm featureNamed: 'B') impliedBy isEmpty.
	self assert: (fm featureNamed: 'B') implying isEmpty.
	
	self assert: (fm featureNamed: 'A') impliedBy isEmpty.
	self assert: (fm featureNamed: 'A') implying isEmpty.
! !

!FMFeatureTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/6/2012 17:35'!
testExclusion6
	| fm |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B [C] [D] ; A -> !! (B | C) ; )'.
	
	self assert: (fm featureNamed: 'A') impliedBy isEmpty.
	self assert: (fm featureNamed: 'B') impliedBy isEmpty.
	self assert: (fm featureNamed: 'C') impliedBy isEmpty.

	self assert: (fm featureNamed: 'B') exclusions = { fm featureNamed: 'A' }.
	self assert: (fm featureNamed: 'A') exclusions = { fm featureNamed: 'B' .  fm featureNamed: 'C' }.
	
	self assert: (fm featureNamed: 'B') numberOfExclusions = 1.
	self assert: (fm featureNamed: 'C') numberOfExclusions = 1.
	self assert: (fm featureNamed: 'A') numberOfExclusions = 2.! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 11:00'!
testHash

	| fm1 fm2 fm3 |
	fm1 := FMFeature new name: 'A'.
	fm2 := FMFeature new name: 'A'.
	fm3 := FMFeature new name: 'AA'.
	self assert: fm1 hash = fm2 hash.
	
	self assert: fm1 hash ~= fm3 hash.
	! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:32'!
testMooseName

	| fm |
	fm := FMFeatureModel new.
	self assert: fm mooseName isString! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:35'!
testMooseName2

	| fm str |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B C [D];)'.
	self assert: fm mooseName isString.
	
	str := WriteStream on: String new.
	fm mooseNameOn: str.
	self assert: str contents isString! !

!FMFeatureTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/6/2012 17:04'!
testSubFeatureKind

	| fm str |
	fm := FMASTBuilder new featureModel parse: 'FM (A : B (C | D)? [E] (F | G)+ (H | I | J); )'.
	self assert: fm numberOfFeatures = 10.
	
	self assert: (fm featureNamed: 'A') isMandatory.
	self assert: (fm featureNamed: 'B') isMandatory.

	self assert: (fm featureNamed: 'C') isMutex.
	self assert: (fm featureNamed: 'D') isMutex.
	
	self assert: (fm featureNamed: 'E') isOptional.
	
	self assert: (fm featureNamed: 'F') isOr.
	self assert: (fm featureNamed: 'G') isOr.
	
	self assert: (fm featureNamed: 'H') isXor.
	self assert: (fm featureNamed: 'I') isXor.
	self assert: (fm featureNamed: 'J') isXor.
	
	self deny: (fm featureNamed: 'J') isOptional.
	self deny: (fm featureNamed: 'E') isXor.! !

FMTest subclass: #FMImportCommandTest
	instanceVariableNames: 'command'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMImportCommandTest methodsFor: 'running' stamp: 'AlexandreBergel 7/3/2012 16:18'!
setUp

	command := FMTextImportCommand new.! !

!FMImportCommandTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 16:51'!
testIsParseable
	self assert: (command isParseable: 'foobar = FM (A : B C [D] ;)').
	"self deny: (command isParseable: 'foobar = FM ((A : B C [D] ;)')."! !

!FMImportCommandTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 14:39'!
testParse
	| model |
	model := command modelForTextualDescription: 'foobar = FM (A : B C [D] ;)'.
	self assert: (model class == MooseModel).
	
	self assert: (model allFeatureModels size = 1).
	self assert: (model allAssignments size = 1).
	self assert: (model allFeatures size = 4).
	self assert: (model allFeatures allSatisfy: [ :f | f featureModel notNil ]).
	self assert: (model allFeatureModels allSatisfy: [ :fm | fm features allSatisfy: [ :f | f featureModel == fm ] ] ).
	
	"self assert: (model allVariables) = {'foobar'}"
	! !

FMTest subclass: #FMParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

FMParserTest subclass: #FMASTBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMASTBuilderTest methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 09:30'!
parser
	^ FMASTBuilder new! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:04'!
source1

	^ 'source1 = FM (Source: Product TypeInfo Property;
			  Product: PictureAlbum;
			  PictureAlbum: Picasa;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: Selection [Secured];
			  Selection: (ByTag|ByUrl)+;)
			  
source2 = FM (Source: Product TypeInfo [Property];
			  Product: PictureAlbum;
			  PictureAlbum: Flickr;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: [Secured];)
			  
			  			  
source3 = FM (Source: Product TypeInfo;
			  Product: PictureAlbum;
			  PictureAlbum: PictureDir;
			  TypeInfo: Array;
			  Array: Picture;)
			  
source4 = FM (Source: Product TypeInfo [Property];
			  Product: Twitter;
			  TypeInfo: Array;
			  Array: Tweet;
			  Property: [Secured];)
			  
source5 = FM (Source: Product TypeInfo;
			  Product: NewsFeed;
			  TypeInfo: Array;
			  Array: News;)

			  			  
source6 = FM (Source: Product TypeInfo;
			  Product: Menu;
			  TypeInfo: MenuInfo;)
			  
source7 = FM (Source: Product TypeInfo Property;
			   Product: WeatherBug;
			   TypeInfo: Array;
			   Array: Weather;
			   Property: ForecastDelay;
			   ForecastDelay: (OneDay|ThreeDays|TenDays)+;)
		
source8 = FM (Source: Product TypeInfo;
			  Product: Announcer;
			  TypeInfo: Array;
			  Array: Annonce;)

source9 = FM (Source: Product TypeInfo;
			  Product: Calendar;
			  Calendar: (Agenda | HyperPlanning | GPU);
			  TypeInfo: Array;
			  Array: CalendarEvent;)
			  
source10 = FM (Source: Product TypeInfo;
			   Product: EmergencyManager;
			   TypeInfo: Array;
			   Array: Emergency;)

source11 = FM (Source: Product TypeInfo;
			   Product: ItemListSource;
			   TypeInfo: Array;
			   Array: Item;)			   
source12 = FM (Source: Product TypeInfo;
			   Product: Statistics;
			   TypeInfo: Array;
			   Array: Stat;)	
			    

test1 = FM (Root: Alarm Trigger;
			Trigger: Trigger_Date;)
			
test2 = FM(Racine: Tri Critere;
			Critere: Critere_Date Critere_Poids;)
			  '! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild1
	| c firstChild secondChild thirdChild |
	c := self parser child parse: 'B'.
	self assert: c isCollection.
	self assert: c first class == FMFeatureMendatory.
	self assert: c first feature = (FMFeature named: 'B')
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild2Multiple
	| c firstChild secondChild thirdChild |
	c := self parser children parse: 'B C D'.
	
	self assert: (c class == Array).
	self assert: (c allSatisfy: [ :cc | cc class ==  FMFeatureMendatory ]).
	self assert: c first feature name = 'B'.
	self assert: c second feature name = 'C'.
	self assert: c third  feature name = 'D'.
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild3
	| c thirdChild firstChild secondChild |
	c := self parser children parse: 'B (C | D)+'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class ==  FMFeatureMendatory.
	self assert: firstChild feature name = 'B'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureOr.
	self assert: secondChild feature name = 'C'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureOr.
	self assert: thirdChild feature name = 'D'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild4
	| c thirdChild firstChild secondChild |
	c := self parser children parse: '(C | D)+ B'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class == FMFeatureOr .
	self assert: firstChild feature name = 'C'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureOr.
	self assert: secondChild feature name = 'D'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: thirdChild feature name = 'B'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingChild5
	| c thirdChild firstChild secondChild |
	c := self parser children parse: '(C | D)? B'.
	self assert: c size = 3.

	firstChild := c first.
	self assert: firstChild class == FMFeatureMutex .
	self assert: firstChild feature name = 'C'.
	
	secondChild := c second.
	self assert: secondChild class ==  FMFeatureMutex.
	self assert: secondChild feature name = 'D'.
	
	thirdChild := c third.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: thirdChild feature name = 'B'.
	
! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint1
	| c |
	c := self parser constraint parse: 'C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right name = 'A'.
	self assert: c left name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint2
	| c |
	c := self parser constraint parse: 'C -> A'.
	self assert: c class == FMConstraintArrow.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint3
	| c |
	c := self parser constraint parse: 'C <-> A'.
	self assert: c class == FMConstraintEquiv.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingConstraint4
	| c |
	c := self parser constraint parse: 'C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right  name = 'A'.
	self assert: c left  name = 'C'.! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/7/2012 13:40'!
testBuildingConstraint5
	| c |
	c := self parser constraint parse: 'C | !!A'.
	self assert: c class == FMConstraintPipe.
	self assert: c left  name = 'C'.
	self assert: c right  class == FMConstraintNegated.
	self assert: c right  expr name = 'A'! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/7/2012 13:57'!
testBuildingConstraint6
	| c |
	c := self parser constraint parse: '!!C | A'.
	self assert: c class == FMConstraintPipe.
	self assert: c right  name = 'A'.
	self assert: c left  class == FMConstraintNegated.
	self assert: c left  expr name = 'C'! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/2/2012 11:07'!
testBuildingExample1

	| program assigment feature |
	program := self parser program parse: 'renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)'.
					
	self assert: (program class == FMProgram).
	self assert: (program numberOfStatements = 1).

	assigment := program statementAt: 1.
	self assert: (assigment variable = 'renderers11'). 
	
	feature := assigment featureModel.
	self assert: ((feature productionAt: 1) root name = 'Renderer').
	self assert: ((feature productionAt: 1) numberOfChildren = 3).
	
	self assert: (feature numberOfConstraints isZero).
	self assert: (feature numberOfProductions = 6).! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:07'!
testBuildingFeature1
	| c prod |
	c := self parser featureModel parse: 'FM ( A : B ; )'.
	self assert: c class == FMFeatureModel.
	self assert: c numberOfProductions = 1.
	self assert: c numberOfConstraints  isZero.
	
	prod := (c productionAt: 1).
	self assert: prod root name = 'A'.
	self assert: prod numberOfChildren = 1.
	 
	self assert: (prod childAt: 1 ) feature name = 'B' .! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:08'!
testBuildingFeature2
	| c prod |
	c := self parser featureModel parse: 'FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)'.
	self assert: c class == FMFeatureModel.
	self assert: c numberOfProductions = 6.
	self assert: c numberOfConstraints  isZero.
	
	prod := (c productionAt: 1).
	self assert: prod root name =  'Renderer'.
	self assert: prod numberOfChildren = 3.
	 
	prod := (c productionAt: 6).
	self assert: prod root name =  'CalendarRenderer'.
	self assert: prod numberOfChildren = 1.
	self assert: (prod childAt: 1) feature name = 'RenderCalendarDetail'.	! !

!FMASTBuilderTest methodsFor: 'constraints' stamp: 'AlexandreBergel 7/2/2012 13:29'!
testBuildingNegated
	| c |
	c := self parser constraint parse: '!! A'.
	self assert: c class == FMConstraintNegated.
	self assert: c expr name = 'A'! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction1
	| c firstChild |
	c := self parser production parse: 'A : B'.
	self assert: c class == FMFeatureProduction.
	self assert: c root name = 'A'.
	self assert: c numberOfChildren = 1.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureMendatory.! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction2
	| c firstChild secondChild thirdChild |
	c := self parser production parse: 'A : B C D'.
	self assert: c class == FMFeatureProduction.
	self assert: c root name = 'A'.
	self assert: c numberOfChildren = 3.

	firstChild := c childAt: 1.
	secondChild := c childAt: 2.
	thirdChild := c childAt: 3.
	
	self assert: firstChild feature name = 'B'.
	self assert: secondChild class ==  FMFeatureMendatory.
	self assert: thirdChild class ==  FMFeatureMendatory.
	self assert: secondChild feature name = 'C'.
	self assert: thirdChild feature name  = 'D'.
	! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 11:48'!
testBuildingProduction3
	| c fourthChild |
	c := self parser production parse: 'A : B C D [E]'.
	self assert: c numberOfChildren = 4.

	fourthChild := c childAt: 4.
	
	self assert: fourthChild class ==  FMFeatureOptional.
	self assert: fourthChild feature name = 'E'.
	
	
	! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 12:36'!
testBuildingProduction4
	| c fourthChild firstChild secondChild |
	c := self parser production parse: 'A : (C | D | E | F) +'.
	self assert: c numberOfChildren = 4.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureOr.
	self assert: firstChild feature name = 'C'.
	
	
	fourthChild := c childAt: 4.
	self assert: fourthChild class ==  FMFeatureOr.
	self assert: fourthChild feature name = 'F'.
	
! !

!FMASTBuilderTest methodsFor: 'features' stamp: 'AlexandreBergel 7/2/2012 13:26'!
testBuildingProduction5
	| c thirdChild firstChild secondChild |
	c := self parser production parse: 'A : B (C | D)'.
	self assert: c numberOfChildren = 3.

	firstChild := c childAt: 1.
	self assert: firstChild class ==  FMFeatureMendatory.
	self assert: firstChild feature name = 'B'.
	
	secondChild := c childAt: 2.
	self assert: secondChild class ==  FMFeatureXor.
	self assert: secondChild feature name = 'C'.
	
	thirdChild := c childAt: 3.
	self assert: thirdChild class ==  FMFeatureXor.
	self assert: thirdChild feature name = 'D'.
	
! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 11:30'!
testHierarchy1

	| fm firstFeature |
	fm := self parser featureModel parse: ' FM ( A : B C D; B : E; )'.
	
	self assert: fm numberOfProductions = 2.
	self assert: fm features = (#('A' 'B' 'C' 'D' 'E') collect: [ :n | FMFeature named: n] ).
	self assert: fm numberOfFeatures = 5.
	
	self assert: (fm subFeaturesOf: (FMFeature named: 'A')) = (#('B' 'C' 'D') collect: [ :n | FMFeature named: n] ).
	
	firstFeature := fm features first.
	self assert: firstFeature featureModel == fm.
	self assert: firstFeature subFeatures =  (#('B' 'C' 'D') collect: [ :n | FMFeature named: n] ).! !

!FMASTBuilderTest methodsFor: 'hierarchy' stamp: 'AlexandreBergel 7/2/2012 15:03'!
testHierarchy2

	| fm firstFeature |
	fm := self parser featureModel parse: ' FM ( Z : G; A : B ;)'.
	
	self assert: fm numberOfFeatures = 4.

	self assert: (fm featureNamed: 'A') subFeatures first ==   (fm featureNamed: 'B').
	self assert: (fm featureNamed: 'B') == fm features fourth.
	self assert: (fm featureNamed: 'B') subFeatures isEmpty 
! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/1/2012 16:30'!
testProgram
	| program |
	program := FMASTBuilder new program parse: 
'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'.

	self assert: program numberOfStatements = 13.
	self assert: program lastStatement featureModel numberOfProductions = 11.
	self assert: program lastStatement featureModel numberOfConstraints = 52.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/2/2012 12:38'!
testProgram2
	| fm |
	fm := FMASTBuilder new featureModel  parse: 
'FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'.

	self assert: fm notNil.
	self assert: fm numberOfProductions = 11.
	self assert: fm numberOfConstraints = 52.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/3/2012 16:55'!
testProgram3
	| program |
	program := FMASTBuilder new program  parse: 
'printer = FM(Xerox: Category Environmental Products Technology Price Performance Input Finishing Capabilites PrintControllers Security PaperHandling Output ; 
Category: (WideFormatSolutions|Workflowsoftware|DigitalPrintingPresses|ContinuousFeedPrinters|ProductionPrintersandCopiers|BusinessDevelopment) ; 
Environmental: Dimensions ElectricalRequirements ; 
Products: (ColorProducts|MonoProducts) ; 
Technology: ProcessorImaging Memory PDLs CPU PrintEngine_Zero UserInterface Harddisk NetworkInterfaces ; 
Performance: LineScreens RatedSpeed ScanSpeed Resolution Dutycycle Recommendedaveragemonthlyvolume ; 
Input: AutomaticDoucmentFeeder HighCapacityFeeder OtherInputDevices ElectronicInput Tray ; 
Finishing: (SlitterorMerger|Cutting|Finisher|BookletMaking|HolePunch|OtherFinishingOptions|TapeBound|Stacker|Binder|Stapler|ByPassTransport)+ ; 
Capabilites: PrintedSides ProductColor [OptionalCapabilties] PrintLineManagement MICR StandardCapabilities ; 
PrintControllers: Digitalfrontends ; 
Security: (IPfiltering|Imageoverwrite|Secureprint|IPvSixsupport|Authentication|EncryptedScantoemail)+ ; 
PaperHandling: MediaWeightMinimum MediaDimensionsMaximum MediaDimensionsMinimum MediaTypes Maximumpapercapacitywithoptions MediaWeightMaximum Standardpapercapacity Papersources ; 
Output: (OffsetOutputTray|Stacker_Zero|TopTray)+ ; 
WideFormatSolutions: (WideFormatFinishers|ColorWideFormatPrinters|DigitalWideFormatPrintersandCopiers|SoftwareSolutions) ; 
Workflowsoftware: (FreeflowSoftwareandscanners|Productionprintingsoftware|DFEsandcontrollers) ; 
DigitalPrintingPresses: (ColorDigitalPrintingPress|BandWPublishingDigitalPrintingPress|BandWTransactionDigitalPrintingPress|HighLightColorDigitalPrintingPress) ; 
ProductionPrintersandCopiers: (BandWPrinters|ColorPrinters|BandWPublishing|HighLightColor|BandWTransaction) ; 
Dimensions: (Professional|BasicFinisherModuleDC|FeederModuleWithIntegratedScanner|PrintEngine|MultifunctionFinisherProplus|XeroxDSThreeFiveZeroZeroStacker|SheetfeedandInsertionModule|FinishingTransportModule|XeroxTapeBinder|SheetEnhancementModule|BasicFinisherModule|BasicFinisherModulePlus)+ ; 
ColorProducts: (Malta|Chandon|Pinot|Chamonix|Mykonos) ; 
MonoProducts: (Teak|BB|HLC|Nuvera|QM) ; 
ProcessorImaging: (Black|Color)+ ; 
ScanSpeed: (IntegratedScanner|FreeFlowScanner)+ ; 
Resolution: (Scan|Print|Scantofile|RIP|Black_Zero|Color_Zero)+ ; 
HighCapacityFeeder: (StandardFourtraySheet|RollFeedSolution|OversizedHighCapacitySheetFeedModule)+ ; 
OtherInputDevices: (HighCapacityInsertionModule|PostprintFourtrayPaperInsertionModule|InsertionModule|PostprintOversizedTwotrayPaperInsertionModule)+ ; 
Tray: (TrayFive|TrayThree|TrayFour|TrayOne|TrayTwo)+ ; 
Finisher: (MultifunctionFinisherProfessional|BasicFinisherModulePlus_Zero|BasicFinisherModuleDC|BasicFinisherModule_Zero|MultifunctionFinisherProplus_Zero)+ ; 
PrintedSides: [Duplex] ; 
OptionalCapabilties: (Finishing_Zero|Scanning)+ ; 
MICR: (Yes|No) ; 
StandardCapabilities: (Fax|ProductionPrinting|Reprinting|HighvolumenetworkprintingandThreerdpartyfinishing|Copy|Scan_Zero|ProductionMICRPrinting|Print_Zero|Finishing_One)+ ; 
MediaWeightMinimum: (coated_One|uncoated_One)+ ; 
MediaTypes: (speciality|coated|uncoated)+ ; 
MediaWeightMaximum: (uncoated_Zero|coated_Zero)+ ; 
Standardpapercapacity: (SheetFeedModule|HighCapacitySheetFeedModule|StitchingandBindingoption|HighCapacityStackingOption)+ ; 
Papersources: (HighCapacityStackingOption_Zero|HighCapacitySheetFeedModule_Zero|StitchingandBindingoption_Zero|SheetFeedModule_Zero)+ ;)

v = FM ( A : B ; )
'.

	self assert: program notNil.
	self assert: program numberOfStatements = 2.
	self assert: program numberOfVariables = 2.! !

!FMASTBuilderTest methodsFor: 'programs' stamp: 'AlexandreBergel 7/3/2012 16:56'!
testProgram4

	| v |
	v := (FMASTBuilder new program parse: 'p = FM (A : B_C ; )') numberOfStatements .
	self assert: v = 1! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:45'!
parseFeatureModel: str
	self assert: (FMParser new featureModel matches: str).
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:48'!
parseProgram: str
	self assert: (FMParser new program matches: str).
	! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:47'!
parseStatement: str
	self assert: (FMParser new statement matches: str).
	! !

!FMParserTest methodsFor: 'hooks' stamp: 'AlexandreBergel 7/1/2012 09:24'!
parser
	^ FMParser new! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:24'!
testConstraint1
	self assert: (self parser constraint matches: 'C | A').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testConstraint2
	self assert: (self parser constraint matches: '!! C | A').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testConstraint3
	self assert: (self parser constraint matches: '(C | A)').! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample
	self assert: (self parser featureModel matches: 'FM (A : B C [D]; D : (E|F|G); C : (H|I|J)+ ;  C | I ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample10WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); (RenderAnnonceTitle -> Text);)')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample11WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); (Thumbnails -> !!RenderNewsTitle); )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample2
	self assert: (self parser featureModel matches: 'FM (A : B C [ D ] ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample3
	self assert: (self parser featureModel matches: 'FM ( A : B  ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample4
	self assert: (self parser featureModel matches: 'FM (A : B  C  ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample5
	self assert: (self parser featureModel matches: 'FM (A :  (B  | C); )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample6
	self assert: (self parser featureModel matches: 'FM (A :  (B  | C); A :  (B  | C);  )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample7
	self assert: (self parser featureModel matches: 'FM ( C : (H|I|J) + ;  )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:25'!
testExample8WithConstraint
	self assert: (self parser featureModel matches: 'FM (A : B C [D]; D : (E|F|G); C : (H|I|J)+ ;  !! C | I ; )')! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testExample9WithConstraint

	self assert: (self parser featureModel matches: 'FM (A : B ;  (RenderAnnonceTitle -> Text); )')! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 08:47'!
testExamples

	self parseStatement: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)'! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testIdentifier

	self assert: (self parser fmlIdentifier parse: 'HelloWorld') = 'HelloWorld'! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 14:12'!
testIdentifier2

	self assert: (self parser fmlIdentifier parse: 'Hello World') = 'Hello' ! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 10:24'!
testParsing

	| ast |
	ast := self parser program parse: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)'.
					
	! !

!FMParserTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/1/2012 09:26'!
testProduction
	self assert: (self parser production matches: 'A : B ')! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 09:12'!
testProgram
	self parseProgram: 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'! !

!FMParserTest methodsFor: 'examples' stamp: 'AlexandreBergel 7/1/2012 09:13'!
testProgram2
	self parseProgram: 'rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)
'! !

FMTest subclass: #FMVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Tests'!

!FMVisitorTest methodsFor: 'source' stamp: 'AlexandreBergel 7/2/2012 13:17'!
program1

^ 'Renderers1 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: MosaicAlbum;)
					
renderers2 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Thumbnails;
					Product: AlbumRenderer;
					AlbumRenderer: ThumbnailsPicture;)
					
renderers3 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text [Graphic] Title Logo;
					Graphic: Full;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsDetails;)
					
renderers4 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: News;
					Elements: Text;
					Product: NewsRenderer;
					NewsRenderer: RenderNewsTitle;)	
					
renderers5 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetContent;)
					
renderers6 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Tweet;
					Elements: Text Graphic;
					Graphic: Thumbnails;
					Product: TwitterRenderer;
					TwitterRenderer: RenderTweetFull;)
					
renderers7 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Picture;
					Elements: Graphic;
					Graphic: Full;
					Product: AlbumRenderer;
					AlbumRenderer: FullscreenPicture;)
					
renderers8 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceTitle;)
					
renderers9 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers10 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: Annonce;
					Elements: Text Title Logo;
					Product: AnnounceRenderer;
					AnnounceRenderer: RenderAnnonceDetail;)	
					
renderers11 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text Title;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarDetail;)
					
renderers12 = FM (Renderer: Product TypeInfo Elements;
					TypeInfo: Array;
					Array: CalendarEvent;
					Elements: Text;
					Product: CalendarRenderer;
					CalendarRenderer: RenderCalendarTitle;)
		
					
rendererMerge = FM(Renderer: TypeInfo Product Elements ; 
TypeInfo: Array ; 
Product: (TwitterRenderer|AnnounceRenderer|CalendarRenderer|AlbumRenderer|NewsRenderer) ; 
Elements: (Graphic|Text)+ [Title] [Logo] ; 
Array: (Tweet|Annonce|CalendarEvent|Picture|News) ; 
TwitterRenderer: (RenderTweetContent|RenderTweetFull) ; 
AnnounceRenderer: (RenderAnnonceTitle|RenderAnnonceDetail) ; 
CalendarRenderer: (RenderCalendarDetail|RenderCalendarTitle) ; 
AlbumRenderer: (ThumbnailsPicture|FullscreenPicture) ; 
NewsRenderer: (RenderNewsDetails|RenderNewsTitle) ; 
Graphic: (Thumbnails|Full) ; 
(RenderAnnonceTitle -> Text);
(RenderAnnonceDetail -> !!Graphic);
(RenderTweetFull -> !!Logo);
(Thumbnails -> !!CalendarRenderer);
(CalendarEvent -> Text);
(Picture -> Graphic);
(RenderNewsDetails -> Text);
(Text -> !!FullscreenPicture);
(Annonce -> Text);
(RenderTweetFull -> Thumbnails);
(Title -> !!RenderNewsTitle);
(FullscreenPicture -> Full);
(Full -> !!RenderNewsTitle);
(Title -> !!Tweet);
(TwitterRenderer -> !!Full);
(CalendarRenderer -> !!Logo);
(RenderNewsTitle -> Text);
(Text -> !!Picture);
(RenderAnnonceTitle -> !!Graphic);
(CalendarEvent -> !!Full);
(Full -> !!AnnounceRenderer);
(Thumbnails -> !!RenderNewsDetails);
(Thumbnails -> !!RenderNewsTitle);
(RenderAnnonceDetail -> Title);
(Tweet <-> TwitterRenderer);
(NewsRenderer -> Text);
(RenderNewsDetails -> Logo);
(RenderAnnonceDetail -> Logo);
(CalendarRenderer <-> CalendarEvent);
(Thumbnails -> !!News);
(Picture <-> AlbumRenderer);
(Thumbnails -> !!RenderTweetContent);
(RenderCalendarDetail -> Title);
(Graphic -> !!RenderTweetContent);
(FullscreenPicture -> Graphic);
(Thumbnails -> !!Annonce);
(ThumbnailsPicture -> Thumbnails);
(Graphic -> !!RenderCalendarTitle);
(TwitterRenderer -> Text);
(RenderTweetFull -> Graphic);
(RenderAnnonceTitle -> !!Title);
(RenderNewsDetails -> Title);
(Title -> !!Thumbnails);
(CalendarRenderer -> !!Graphic);
(Title -> !!RenderCalendarTitle);
(Logo -> Title);
(RenderNewsTitle -> !!Graphic);
(NewsRenderer <-> News);
(Logo -> Text);
(AnnounceRenderer -> !!Graphic);
(Title -> Text);
(Annonce <-> AnnounceRenderer);)'! !

!FMVisitorTest methodsFor: 'source' stamp: 'AlexandreBergel 7/2/2012 13:19'!
program2

	^ 'source1 = FM (Source: Product TypeInfo Property;
			  Product: PictureAlbum;
			  PictureAlbum: Picasa;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: Selection [Secured];
			  Selection: (ByTag|ByUrl)+;)
			  
source2 = FM (Source: Product TypeInfo [Property];
			  Product: PictureAlbum;
			  PictureAlbum: Flickr;
			  TypeInfo: Array;
			  Array: Picture;
			  Property: [Secured];)
			  
			  			  
source3 = FM (Source: Product TypeInfo;
			  Product: PictureAlbum;
			  PictureAlbum: PictureDir;
			  TypeInfo: Array;
			  Array: Picture;)
			  
source4 = FM (Source: Product TypeInfo [Property];
			  Product: Twitter;
			  TypeInfo: Array;
			  Array: Tweet;
			  Property: [Secured];)
			  
source5 = FM (Source: Product TypeInfo;
			  Product: NewsFeed;
			  TypeInfo: Array;
			  Array: News;)

			  			  
source6 = FM (Source: Product TypeInfo;
			  Product: Menu;
			  TypeInfo: MenuInfo;)
			  
source7 = FM (Source: Product TypeInfo Property;
			   Product: WeatherBug;
			   TypeInfo: Array;
			   Array: Weather;
			   Property: ForecastDelay;
			   ForecastDelay: (OneDay|ThreeDays|TenDays)+;)
		
source8 = FM (Source: Product TypeInfo;
			  Product: Announcer;
			  TypeInfo: Array;
			  Array: Annonce;)

source9 = FM (Source: Product TypeInfo;
			  Product: Calendar;
			  Calendar: (Agenda | HyperPlanning | GPU);
			  TypeInfo: Array;
			  Array: CalendarEvent;)
			  
source10 = FM (Source: Product TypeInfo;
			   Product: EmergencyManager;
			   TypeInfo: Array;
			   Array: Emergency;)

source11 = FM (Source: Product TypeInfo;
			   Product: ItemListSource;
			   TypeInfo: Array;
			   Array: Item;)			   
source12 = FM (Source: Product TypeInfo;
			   Product: Statistics;
			   TypeInfo: Array;
			   Array: Stat;)	
			      

test1 = FM (Root: Alarm Trigger;
			Trigger: Trigger_Date;)
			
test2 = FM(Racine: Tri Critere;
			Critere: Critere_Date Critere_Poids;)
			  '! !

!FMVisitorTest methodsFor: 'tests' stamp: 'AlexandreBergel 7/2/2012 13:21'!
testVisitor

	| visitorClasses |
	visitorClasses := FMVisitor withAllSubclasses.
	visitorClasses do: [ :vcls |
		#(#program1 #program2 ) do: [ :k | 
			(FMASTBuilder new program parse: (self perform: k)) accept: vcls new ] ] ! !

TestCase subclass: #SPParserTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE-Tests'!

!SPParserTest methodsFor: 'running' stamp: 'AlexandreBergel 11/19/2012 12:28'!
setUp
	super setUp.
	parser := SPParser new.! !

!SPParserTest methodsFor: 'action deselect' stamp: 'AlexandreBergel 11/21/2012 17:48'!
testActionDeselect1
	| actionDeselect |
	
	actionDeselect := parser parseActionDeselect: '[ROASSAL] ActionDeselect id="AD_0" feature=[PictureAlbum] fm=[fm_renderer]'.
	
	self assert: actionDeselect name = 'AD_0'.
	self assert: actionDeselect feature = #('PictureAlbum').
	self assert: actionDeselect fm = #('fm_renderer').! !

!SPParserTest methodsFor: 'action select' stamp: 'AlexandreBergel 11/21/2012 17:51'!
testActionSelect1
	| actionDeselect |
	
	actionDeselect := parser parseActionSelect: '[ROASSAL] ActionSelect id="AS_0" feature=[Calendar] fm=[fm_renderer]'.
	
	self assert: actionDeselect name = 'AS_0'.
	self assert: actionDeselect feature = #('Calendar').
	self assert: actionDeselect fm = #('fm_renderer').! !

!SPParserTest methodsFor: 'begin end' stamp: 'AlexandreBergel 11/19/2012 12:27'!
testBeginEnd

	self should: [ parser parse: '' ] raise: Error.
	self should: [ parser parse: '[ROASSAL] BEGIN MODEL' ] raise: Error.
	self should: [ parser parse: '[ROASSAL] END MODEL' ] raise: Error.
	
	self shouldnt: [ parser parse: '[ROASSAL] BEGIN MODEL', String cr, '[ROASSAL] END MODEL' ] raise: Error.
	self shouldnt: [ parser parse: '>> list of FeatureModels', String cr, 
									'[ROASSAL] BEGIN MODEL', String cr, 
									'[ROASSAL] END MODEL' ] raise: Error.! !

!SPParserTest methodsFor: 'domain element' stamp: 'AlexandreBergel 11/20/2012 10:12'!
testDomainElement1
	| domainElement |
	
	domainElement := parser parseDomainElement: '[ROASSAL] DomainElement id="Source" MultiplicityElement=ME(1,-1) belongs_to=[AssociationSourceRenderer,AssociationRendererSource] refers_on=[Source]'.
	
	self assert: domainElement name = 'Source'.
	self assert: domainElement belongsTo = #('AssociationSourceRenderer' 'AssociationRendererSource').
	self assert: domainElement refersOn = #('Source').! !

!SPParserTest methodsFor: 'domain element' stamp: 'AlexandreBergel 11/21/2012 17:54'!
testDomainElement2
	| domainElement |
	
	domainElement := parser parseDomainElement: '[ROASSAL] DomainElement id="source" refers_on=[fm_source] MultiplicityElement=[me_DE_source] belongs_to=[AssoSourceRenderer,AssoRendererSource]'.
	
	self assert: domainElement name = 'source'.
	self assert: domainElement belongsTo = #('AssoSourceRenderer' 'AssoRendererSource').
	self assert: domainElement refersOn = #('fm_source').
	self assert: domainElement multiplicityElement = #('me_DE_source').! !

!SPParserTest methodsFor: 'domain element' stamp: 'AlexandreBergel 11/21/2012 17:40'!
testDomainElementEnd1
	| domainElementEnd |
	
	domainElementEnd := parser parseDomainElementEnd: '[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_source" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_source]'.
	
	self assert: domainElementEnd name = 'DEAEnd_AssoSourceRenderer_source'.
	self assert: domainElementEnd applyOn = #('source').
	self assert: domainElementEnd linkMultiplicity = #('me_DEAEnd_AssoSourceRenderer_source').! !

!SPParserTest methodsFor: 'feature model' stamp: 'AlexandreBergel 11/19/2012 17:28'!
testFeatureModel1
	| featureModel |
	featureModel := parser parseFeatureModel: '[ROASSAL] FeatureModel id="Source" FM(Source: TypeInfo Product; TypeInfo: (PictureAlbum|Calendar); Product: (Picasa|FlickR|ICalReader); PictureAlbum <-> (Picasa or FlickR); Calendar <-> ICalReader;)'.
	
	self assert: featureModel class == SPFeatureModel.
	self assert: featureModel name = 'Source'.
	
	self assert: featureModel fmFeatureModel notNil.
	self assert: featureModel fmFeatureModel numberOfFeatures = 8.! !

!SPParserTest methodsFor: 'testing utility' stamp: 'AlexandreBergel 11/20/2012 09:52'!
testGetIdFrom

	self assert: (parser getIdFrom: '[ROASSAL] DomainElement id="Source" Multipli') = 'Source'.
	self assert: (parser getIdFrom: '[ROASSAL] RestrictionFunction id="RendererSourceTypeInfo" rules=[TypeInfo3,TypeInfo4]') = 'RendererSourceTypeInfo'.! !

!SPParserTest methodsFor: 'testing utility' stamp: 'AlexandreBergel 11/20/2012 10:09'!
testGetListNamedFrom

	self assert: (parser getListNamed: 'rules' from: '[ROASSAL] RestrictionFunction id="SourceRendererTypeInfo" rules=[TypeInfo1,TypeInfo2]')
					= #('TypeInfo1' 'TypeInfo2').

	self assert: (parser getListNamed: 'restrictionFunctions' from: '[ROASSAL] FMAssociation id="AssociationZoneRenderer" source=FMAEnd(apply_on=[Zone] LinkMultiplicity=ME(1,1)) target=FMAEnd(apply_on=[Renderer] LinkMultiplicity=ME(1,-1)) restrictionFunctions=[ZoneRendererElements]')
					= #('ZoneRendererElements').
					
	self assert: (parser getListNamed: 'belongs_to' from: '[ROASSAL] DomainElement id="Source" MultiplicityElement=ME(1,-1) belongs_to=[AssociationSourceRenderer,AssociationRendererSource] refers_on=[Source]') = #('AssociationSourceRenderer' 'AssociationRendererSource')! !

!SPParserTest methodsFor: 'begin end' stamp: 'AlexandreBergel 11/19/2012 15:56'!
testTag

	self should: [ parser assertBeginWithTag: '>> list of FeatureModels' ] raise: Error.
	self shouldnt: [ parser assertBeginWithTag: '[ROASSAL] FeatureModel' ] raise: Error! !

!SPParserTest methodsFor: 'example' stamp: 'AlexandreBergel 11/21/2012 17:35'!
trace1

^'[ROASSAL] BEGIN MODEL
>> list of FeatureModel
[ROASSAL] FeatureModel id="fm_source" FM(Source: TypeInfo Product ;  TypeInfo: (Calendar|PictureAlbum) ;  Product: (ICalReader|FlickR|Picasa) ;  (Calendar <-> ICalReader); (PictureAlbum <-> (Picasa | FlickR));)
[ROASSAL] FeatureModel id="fm_renderer" FM(Renderer: TypeInfo Product Elements ;  TypeInfo: (Calendar|PictureAlbum) ;  Product: (CalendarDisplay|PictureAlbumSlide|PictureAlbumMosaic) ;  Elements: Content [Title] [Logo] ;  Content: (Graphic|Text)+ ;  (PictureAlbum <-> (PictureAlbumMosaic | PictureAlbumSlide)); (Calendar <-> CalendarDisplay); (Calendar -> (Logo & Text)); ((PictureAlbumMosaic | PictureAlbumSlide) -> (Title & Graphic));)
[ROASSAL] FeatureModel id="fm_zone" FM(Zone: Product Elements ;  Product: MainZone [ScrollingBar] ;  Elements: Content [Title] [Logo] ;  Content: (Graphic|Text)+ ;  (ScrollingBar -> (Logo & Text)); (MainZone -> (((Title & Logo) & Text) & Graphic));)
[ROASSAL] FeatureModel id="fm_layout" FM(Layout: Zone Product ;  Zone: MainZone [ScrollingBar] ;  Product: (EPU|CA) ;  (EPU <-> ScrollingBar);)
>> list of DEAEnd
[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_source" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoSourceRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoSourceRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererSource_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererSource_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererSource_target" apply_on=[source] linkMultiplicity=[me_DEAEnd_AssoRendererSource_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererZone_source" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoRendererZone_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoRendererZone_target" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoRendererZone_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneRenderer_source" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoZoneRenderer_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneRenderer_target" apply_on=[renderer] linkMultiplicity=[me_DEAEnd_AssoZoneRenderer_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneLayout_source" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoZoneLayout_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoZoneLayout_target" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoZoneLayout_target]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutZone_source" apply_on=[layout] linkMultiplicity=[me_DEAEnd_AssoLayoutZone_source]
[ROASSAL] DEAEnd id="DEAEnd_AssoLayoutZone_target" apply_on=[zone] linkMultiplicity=[me_DEAEnd_AssoLayoutZone_target]
>> list of ActionDeselect
[ROASSAL] ActionDeselect id="AD_0" feature=[PictureAlbum] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_1" feature=[Calendar] fm=[fm_renderer]
[ROASSAL] ActionDeselect id="AD_2" feature=[PictureAlbum] fm=[fm_source]
[ROASSAL] ActionDeselect id="AD_3" feature=[Calendar] fm=[fm_source]
>> list of ActionSelect
[ROASSAL] ActionSelect id="AS_0" feature=[Calendar] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_1" feature=[PictureAlbum] fm=[fm_renderer]
[ROASSAL] ActionSelect id="AS_2" feature=[Calendar] fm=[fm_source]
[ROASSAL] ActionSelect id="AS_3" feature=[PictureAlbum] fm=[fm_source]
>> list of DomainElement
[ROASSAL] DomainElement id="source" refers_on=[fm_source] MultiplicityElement=[me_DE_source] belongs_to=[AssoSourceRenderer,AssoRendererSource]
[ROASSAL] DomainElement id="renderer" refers_on=[fm_renderer] MultiplicityElement=[me_DE_renderer] belongs_to=[AssoSourceRenderer,AssoRendererSource,AssoRendererZone,AssoZoneRenderer]
[ROASSAL] DomainElement id="zone" refers_on=[fm_zone] MultiplicityElement=[me_DE_zone] belongs_to=[AssoRendererZone,AssoZoneRenderer,AssoZoneLayout,AssoLayoutZone]
[ROASSAL] DomainElement id="layout" refers_on=[fm_layout] MultiplicityElement=[me_DE_layout] belongs_to=[AssoZoneLayout,AssoLayoutZone]
>> list of MultiplicityElement
[ROASSAL] MultiplicityElement id="me_DE_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DE_renderer" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DE_zone" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DE_layout" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoSourceRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoSourceRenderer_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererSource_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererSource_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererZone_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoRendererZone_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneRenderer_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneRenderer_target" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneLayout_source" lowerBound=1 upperBound=-1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoZoneLayout_target" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutZone_source" lowerBound=1 upperBound=1
[ROASSAL] MultiplicityElement id="me_DEAEnd_AssoLayoutZone_target" lowerBound=1 upperBound=-1
>> list of ConfigurationState
[ROASSAL] ConfigurationState id="cs_Rule_0" fm=[fm_source] selected=[Calendar] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_1" fm=[fm_source] selected=[PictureAlbum] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_2" fm=[fm_renderer] selected=[Calendar] deselected=[]
[ROASSAL] ConfigurationState id="cs_Rule_3" fm=[fm_renderer] selected=[PictureAlbum] deselected=[]
>> list of Rule
[ROASSAL] Rule id="Rule_0" state=[cs_Rule_0] actions=[AS_0,AD_0]
[ROASSAL] Rule id="Rule_1" state=[cs_Rule_1] actions=[AS_1,AD_1]
[ROASSAL] Rule id="Rule_2" state=[cs_Rule_2] actions=[AS_2,AD_2]
[ROASSAL] Rule id="Rule_3" state=[cs_Rule_3] actions=[AS_3,AD_3]
>> list of DEAssociation
[ROASSAL] DEAssociation id="AssoSourceRenderer" source=[DEAEnd_AssoSourceRenderer_source] target=[DEAEnd_AssoSourceRenderer_target] restrictionFunctions=[SourceRendererTypeInfo]
[ROASSAL] DEAssociation id="AssoRendererSource" source=[DEAEnd_AssoRendererSource_source] target=[DEAEnd_AssoRendererSource_target] restrictionFunctions=[RendererSourceTypeInfo]
[ROASSAL] DEAssociation id="AssoRendererZone" source=[DEAEnd_AssoRendererZone_source] target=[DEAEnd_AssoRendererZone_target] restrictionFunctions=[]
[ROASSAL] DEAssociation id="AssoZoneRenderer" source=[DEAEnd_AssoZoneRenderer_source] target=[DEAEnd_AssoZoneRenderer_target] restrictionFunctions=[]
[ROASSAL] DEAssociation id="AssoZoneLayout" source=[DEAEnd_AssoZoneLayout_source] target=[DEAEnd_AssoZoneLayout_target] restrictionFunctions=[]
[ROASSAL] DEAssociation id="AssoLayoutZone" source=[DEAEnd_AssoLayoutZone_source] target=[DEAEnd_AssoLayoutZone_target] restrictionFunctions=[]
>> list of RestrictionFunction
[ROASSAL] RestrictionFunction id="SourceRendererTypeInfo" rules=[Rule_0,Rule_1]
[ROASSAL] RestrictionFunction id="RendererSourceTypeInfo" rules=[Rule_2,Rule_3]
[ROASSAL] END MODEL'! !

MPImportCommand subclass: #FMTextImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Moose'!

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:33'!
chooseDirectory
	"Let the user pick a folder. Load in Moose all the fml file contained in the folder"
	| dir file |
	dir := UIManager default chooseDirectory.
	dir ifNil: [ ^ self ].

	(dir fileNamesMatching: '*.fml') do: [ :fileName |
		self processFileNamed: (dir fullNameFor: fileName) ].
	
! !

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:35'!
chooseFile
	| fileName file |
	fileName := UIManager default chooseFullFileNameMatching: #('*.fml').
	(fileName isNil or: [ fileName isEmpty ]) ifTrue: [ ^ self ].
	self self processFileNamed: fileName ! !

!FMTextImportCommand methodsFor: 'callback' stamp: 'AlexandreBergel 7/6/2012 11:12'!
enterTextualDescription
	| str |
	str := UIManager default 
			multiLineRequest: 'Enter a program' initialAnswer: 'enter your Familiar program' answerHeight: 250.
	self processText: str ! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/6/2012 11:28'!
execute
	| str sel fileName file |
	sel := UIManager default 
			chooseFrom:  #('choose file' 'choose folder' 'enter textual description') 
			values: #(#chooseFile #chooseDirectory #enterTextualDescription).
	sel ifNil: [ ^ self ].
	
	self perform: sel
	! !

!FMTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 7/1/2012 16:48'!
isParseable: string
	^ FMASTBuilder new program matches: string! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/6/2012 11:27'!
label
	^ 'Import Familiar description'! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/2/2012 00:13'!
modelForTextualDescription: string
	"parse string and fill up a moose model. string has to correspond to a program"
	
	| model program collectingVisitor |
	
	"Make sure that the code is parseable"
	self assert: [ self isParseable: string ] description: 'Entered code is not parseable. Please check'.
	model := MooseModel new.
	
	program := FMASTBuilder new program parse: string.
	collectingVisitor := CollectingVisitor new.
	program accept: collectingVisitor.
	model addAll: collectingVisitor elements.
	
	^ model
	! !

!FMTextImportCommand methodsFor: 'util' stamp: 'AlexandreBergel 7/6/2012 11:27'!
processFileNamed: fileName
	| file |
	[file := FileStream fileNamed: fileName.
	self processText: file contents titled: file localName ]
		on: Error do: [ :ex | 
			UIManager default inform: ex printString.
			file ifNotNil: [ file close ] ] ! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/3/2012 16:54'!
processText: str
	self processText: str titled: 'no name'! !

!FMTextImportCommand methodsFor: 'hooks' stamp: 'AlexandreBergel 7/3/2012 16:53'!
processText: str titled: title
	(str notNil and: [ str notEmpty ])
			ifTrue: [ MooseModel root add: ((self modelForTextualDescription: str) name: title) ]! !

Object subclass: #FMParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

FMParser subclass: #FMASTBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:31'!
children
	^ super children ==> [ :node | node flatten ]! !

!FMASTBuilder methodsFor: 'public' stamp: 'AlexandreBergel 7/7/2012 14:17'!
constraint
	| term prim |
	
	term := PPDelegateParser new.
	prim := PPDelegateParser new.
	
	term setParser: ((self fmlIdentifier trim,  self constraintOperator , prim) ==> [ :n |  n second new left: n first ; right: n third; yourself  ] ) /
					(($!! asParser trim, self fmlIdentifier trim,  self constraintOperator , prim) ==> [ :n |  n third new left: (FMConstraintNegated new expr: n second) ; right: n fourth; yourself  ]) /

					((prim trim,  self constraintOperator , prim) ==> [ :n |  n second new left: n first ; right: n third; yourself  ] ) / 
					prim.
	prim setParser: 
		
		($( asParser trim , term , $) asParser trim ==> [ :n | n second ]) /
		(($!! asParser trim, term) ==> [ :n | FMConstraintNegated new expr: n second ]) /
		(self fmlIdentifier trim ==> [ :n | n ]) 
				.

	^ term! !

!FMASTBuilder methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 17:23'!
constraintOperator
	^ ( '|'  asParser trim / 
						 'or'  asParser trim / 
						 'and'  asParser trim / 
						'&' asParser trim / 
						'->' asParser trim  /  
						'<->' asParser trim) ==> [ :n | FMConstraintBinOp for: n ] ! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 14:39'!
featureModel
	^ super featureModel ==> [ :node | 
		| prods cons fm |
		prods := node third collect: #first. 
		cons := node fourth flatten reject: [ :n | n = $; ]. 
		
		fm := FMFeatureModel new 
			addAllExpressions: prods;
			addAllConstraints: cons;
			yourself.
		fm features do: [ :f | f featureModel: fm ].
		fm ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 10:56'!
fmlIdentifier
	^ super fmlIdentifier ==> [ :node | FMFeature new name: node ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:26'!
mandatory
	^ super mandatory ==> [ :node | Array with: (FMFeatureMendatory new feature: node) ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:27'!
mutexgroup
	^ super mutexgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureMutex new feature: n ] ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:28'!
optional
	^ super optional ==> [ :node |  Array with: (FMFeatureOptional new feature: node second) ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:21'!
orgroup
	^ super orgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureOr new feature: n ] ]! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:58'!
production
	^ super production ==> [ :nodes | 
		FMFeatureProduction new 
			root: nodes first ; 
			addAll: nodes third ; 
			yourself ]
! !

!FMASTBuilder methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:59'!
xorgroup
	^ super xorgroup ==> [ :node | 
		| featureNames |
		featureNames := OrderedCollection new.
		featureNames add: node second.
		featureNames addAll: (node third collect: #second).
		featureNames collect: [ :n | FMFeatureXor new feature: n ] ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:05'!
child
	^ self mandatory / self orgroup / self mutexgroup / self optional / self xorgroup ! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 10:56'!
children
	^ self child plus! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 17:20'!
constraint
	| term prim |
	
	term := PPDelegateParser new.
	prim := PPDelegateParser new.
	
	term setParser: ( prim,  ( 'or' asParser trim / 'and' asParser trim / '|'  asParser trim / '&' asParser trim / '->' asParser trim  /  '<->' asParser trim ) , prim) / 
					prim.
	prim setParser: ($( asParser trim , term , $) asParser trim) /
					($!! asParser trim, term) /
				self id.
					
	^ term! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:22'!
featureModel
	
	^ 'FM' asParser trim , self leftPar ,  ((self production  , self semiColumn ) plus) ,  (self constraint  , self semiColumn ) star , self rightPar
! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/3/2012 16:07'!
fmlIdentifier
	^ (#letter asParser , ( #letter asParser / #digit asParser / $_ asParser) star) flatten trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 11:03'!
id
	^  (#letter asParser , ( #letter asParser / #digit asParser ) star) flatten trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 6/30/2012 22:13'!
leftPar 
	^ $( asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:47'!
mandatory
	"Mandatory   : name=ID ;
	ID : ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*; "
	
	^ self fmlIdentifier ! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:35'!
mutexgroup
	"Mutexgroup   : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN '?' ;"

	^ $( asParser , self fmlIdentifier  , ( $| asParser , self fmlIdentifier ) plus ,  $) asParser , $? asParser! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 11:51'!
optional
	"Optional    : '[' name=FML_IDENTIFIER ']' ;"
	^ '[' asParser trim , self fmlIdentifier , ']' asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 12:35'!
orgroup
	"Orgroup    : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN '+' ;"

	^ self leftPar  , self fmlIdentifier , ( self verticalBar  , self fmlIdentifier ) plus ,  self rightPar  , $+ asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 10:56'!
production
	^ (self fmlIdentifier ,  ':' asParser trim , self children) trim! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:06'!
program
	^ self statement star ==> [ :node | FMProgram new addAll: node ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 6/30/2012 22:14'!
rightPar 
	^ $) asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 01:59'!
semiColumn
	^ $; asParser trim! !

!FMParser methodsFor: 'public' stamp: 'AlexandreBergel 7/1/2012 15:05'!
statement
	^ (self id , $= asParser trim, self featureModel) ==>
			 [ :node | FMAssignment new variable: node first; featureModel: node third ]! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/1/2012 01:58'!
verticalBar 
	^ $| asParser trim! !

!FMParser methodsFor: 'private' stamp: 'AlexandreBergel 7/2/2012 13:03'!
xorgroup
	"Xorgroup   : LEFT_PAREN features+=ID  ('|' features+=ID)+ RIGHT_PAREN ;"

	^ self leftPar , self fmlIdentifier , ( self verticalBar , self fmlIdentifier ) plus ,  self rightPar! !

Object subclass: #FMVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

FMVisitor subclass: #CollectingVisitor
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/3/2012 14:31'!
constains: object
	^ elements includes: object! !

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 14:27'!
elements
	^ elements asSet asOrderedCollection! !

!CollectingVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 15:06'!
elementsOfKind: aClass
	^ self elements select: [ :el | el isKindOf: aClass ]! !

!CollectingVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 00:22'!
initialize 
	super initialize.
	elements := OrderedCollection new ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitAssigment: aFMAssignment 
	elements add: aFMAssignment ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 17:02'!
visitConstraintAnd: aFMConstraintAnd 
	elements add: aFMConstraintAnd ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:38'!
visitConstraintArrow: aFMConstraintArrow 
	elements add: aFMConstraintArrow ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
visitConstraintEquiv: aFMConstraintEquiv
	elements add: aFMConstraintEquiv ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:38'!
visitConstraintNegated: aFMConstraintNegated 
	elements add: aFMConstraintNegated ! !

!CollectingVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:15'!
visitConstraintPipe: aFMConstraintPipe
	elements add: aFMConstraintPipe ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 14:26'!
visitFeature: aFMFeature 
	elements add: aFMFeature ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitFeatureModel: aFMFeatureModel 
	elements add: aFMFeatureModel ! !

!CollectingVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:21'!
visitProgram: aFMProgram 
	elements add: aFMProgram ! !

FMVisitor subclass: #CountingFeatureVisitor
	instanceVariableNames: 'features'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!CountingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/2/2012 11:18'!
features 
	^ features asArray! !

!CountingFeatureVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/2/2012 10:49'!
initialize
	super initialize.
	features := OrderedCollection new.! !

!CountingFeatureVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:19'!
visitFeature: aFMFeature 
	(features includes: aFMFeature)
		ifFalse: [ features add: aFMFeature ]! !

FMVisitor subclass: #FMCollectingFeatureVisitor
	instanceVariableNames: 'featuresImplying featuresImplied focusedFeature exclusions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-Visitor'!

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/6/2012 16:44'!
exclusions
	^ exclusions asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:35'!
featuresImplied
	^ featuresImplied asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:34'!
featuresImplying
	^ featuresImplying asArray! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:22'!
focusedFeature
	^ focusedFeature! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/4/2012 17:22'!
focusedFeature: anObject
	focusedFeature := anObject! !

!FMCollectingFeatureVisitor methodsFor: 'initialize-release' stamp: 'AlexandreBergel 7/6/2012 16:19'!
initialize 
	super initialize.
	featuresImplying := OrderedCollection new.
	featuresImplied := OrderedCollection new.
	exclusions := OrderedCollection new! !

!FMCollectingFeatureVisitor methodsFor: 'accessing' stamp: 'AlexandreBergel 7/7/2012 14:17'!
visitConstraintArrow: aFMConstraintArrow 
	| c featuresRight featuresLeft |

"self halt."

	"We ignore not on the left hand side"
	(aFMConstraintArrow left class == FMConstraintNegated) ifTrue: [ ^ self ].

	"We get what features is on the left hand side"
	c := CollectingVisitor new.
	aFMConstraintArrow left accept: c.
	featuresLeft := c elementsOfKind: FMFeature. 

	"We get what features is on the right hand side"
	c := CollectingVisitor new.
	aFMConstraintArrow right accept: c.
	featuresRight := c elementsOfKind: FMFeature. 


	(aFMConstraintArrow right class == FMConstraintNegated) 
		ifTrue: [
			(featuresRight includes: focusedFeature) ifTrue: [ exclusions addAll: featuresLeft ].
			(featuresLeft includes: focusedFeature) ifTrue: [ exclusions addAll: featuresRight ] ]
		ifFalse: [
			(featuresRight includes: focusedFeature) ifTrue: [ featuresImplied addAll: featuresLeft ].
			(featuresLeft includes: focusedFeature) ifTrue: [ featuresImplying addAll: featuresRight ] ]
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:15'!
visitAssigment: aFMAssignment 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/4/2012 16:46'!
visitConstraintAnd: aFMConstraintAnd 
! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 14:13'!
visitConstraintArrow: aFMConstraintArrow 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:11'!
visitConstraintEquiv: aFMConstraintEquiv 
	! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/2/2012 13:30'!
visitConstraintNegated: aFMConstraintNegated 
! !

!FMVisitor methodsFor: 'visiting constraints' stamp: 'AlexandreBergel 7/3/2012 15:15'!
visitConstraintPipe: aFMConstraintPipe 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 11:13'!
visitFeature: aFMFeature 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:17'!
visitFeatureModel: aFMFeatureModel 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:14'!
visitProgram: aFMProgram 
	! !

!FMVisitor methodsFor: 'visiting' stamp: 'AlexandreBergel 7/2/2012 00:16'!
visitVariable: aVariable 
	! !

Object subclass: #SPObject
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

SPObject subclass: #SPAbstractAction
	instanceVariableNames: 'fm feature'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
feature
	^ feature! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
feature: anObject
	feature := anObject! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
fm
	^ fm! !

!SPAbstractAction methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:52'!
fm: anObject
	fm := anObject! !

SPAbstractAction subclass: #SPActionDeselect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

SPAbstractAction subclass: #SPActionSelect
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

SPObject subclass: #SPDomainElement
	instanceVariableNames: 'belongsTo refersOn multiplicityElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
belongsTo
	^ belongsTo! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
belongsTo: anObject
	belongsTo := anObject! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:53'!
multiplicityElement
	^ multiplicityElement! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:53'!
multiplicityElement: anObject
	multiplicityElement := anObject! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
refersOn
	^ refersOn! !

!SPDomainElement methodsFor: 'accessing' stamp: 'AlexandreBergel 11/20/2012 10:07'!
refersOn: anObject
	refersOn := anObject! !

SPObject subclass: #SPDomainElementEnd
	instanceVariableNames: 'applyOn linkMultiplicity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
applyOn
	^ applyOn! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
applyOn: anObject
	applyOn := anObject! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
linkMultiplicity
	^ linkMultiplicity! !

!SPDomainElementEnd methodsFor: 'accessing' stamp: 'AlexandreBergel 11/21/2012 17:36'!
linkMultiplicity: anObject
	linkMultiplicity := anObject! !

SPObject subclass: #SPFeatureModel
	instanceVariableNames: 'fmFeatureModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:05'!
fmFeatureModel
	^ fmFeatureModel! !

!SPFeatureModel methodsFor: 'accessing' stamp: 'AlexandreBergel 11/19/2012 16:05'!
fmFeatureModel: anObject
	fmFeatureModel := anObject! !

!SPObject methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 16:04'!
name
	^ name! !

!SPObject methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 11/19/2012 16:04'!
name: aName
	name := aName! !

Object subclass: #SPParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Familiar-SPINE'!

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:55'!
assertBeginWithTag: string
	(string beginsWith: '[ROASSAL] ')
		ifFalse: [ self error: 'Improper tag' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:49'!
assertContainsBeginStatement: lines
	(self containsBeginStatement: lines)
		ifFalse: [ self error: 'Missing begin statement' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:50'!
assertContainsEndingStatement: lines
	(self containsEndingStatement: lines)
		ifFalse: [ self error: 'Missing ending statement' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:48'!
containsBeginStatement: lines
	^ lines anySatisfy: [ :line | line = '[ROASSAL] BEGIN MODEL' ]! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:48'!
containsEndingStatement: lines
	^ lines anySatisfy: [ :line | line = '[ROASSAL] END MODEL' ]! !

!SPParser methodsFor: 'util' stamp: 'AlexandreBergel 11/20/2012 09:51'!
getIdFrom: featureModelString
	"Extract the id in a string"
	
	| idBinding |
	idBinding := featureModelString substrings third.
	self assert: [ idBinding beginsWith: 'id="' ].
	^ idBinding copyFrom: 'id="' size + 1 to: idBinding size - 1! !

!SPParser methodsFor: 'util' stamp: 'AlexandreBergel 11/20/2012 10:11'!
getListNamed: keyName from: stringToExtractFrom 
	| indexKey endingWhiteSpaceIndex str |
	indexKey := stringToExtractFrom indexOfSubCollection: keyName.
	endingWhiteSpaceIndex := stringToExtractFrom indexOf: $  startingAt: indexKey ifAbsent: [ stringToExtractFrom size + 1].
	
	str := stringToExtractFrom copyFrom: (indexKey + keyName size + 2)  to: (endingWhiteSpaceIndex - 2).
	^ str subStrings: ','
! !

!SPParser methodsFor: 'public' stamp: 'AlexandreBergel 11/19/2012 12:25'!
parse: aString
	"Public method"

	^ self parseLines: aString lines ! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/21/2012 17:48'!
parseActionDeselect: actionDeselectString

	| actionDeselect | 
	self assertBeginWithTag: actionDeselectString.

	actionDeselect := SPActionDeselect new
						name: (self getIdFrom: actionDeselectString);
						feature: (self getListNamed: 'feature' from: actionDeselectString);
						fm: (self getListNamed: 'fm' from: actionDeselectString);
						yourself.
						
	^ actionDeselect 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/21/2012 17:52'!
parseActionSelect: actionDeselectString

	| actionDeselect | 
	self assertBeginWithTag: actionDeselectString.

	^ SPActionSelect new
						name: (self getIdFrom: actionDeselectString);
						feature: (self getListNamed: 'feature' from: actionDeselectString);
						fm: (self getListNamed: 'fm' from: actionDeselectString);
						yourself.
						 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/21/2012 17:54'!
parseDomainElement: domainElementString

	| domainElement | 
	self assertBeginWithTag: domainElementString.

	domainElement := SPDomainElement new
						name: (self getIdFrom: domainElementString);
						belongsTo: (self getListNamed: 'belongs_to' from: domainElementString);
						refersOn: (self getListNamed: 'refers_on' from: domainElementString);
						multiplicityElement: (self getListNamed: 'MultiplicityElement' from: domainElementString);
						yourself.
						
	^ domainElement 
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/21/2012 17:38'!
parseDomainElementEnd: domainElementEndString

	| domainElementEnd | 
	self assertBeginWithTag: domainElementEndString.

	domainElementEnd := SPDomainElementEnd new
						name: (self getIdFrom: domainElementEndString);
						applyOn: (self getListNamed: 'apply_on' from: domainElementEndString);
						linkMultiplicity: (self getListNamed: 'linkMultiplicity' from: domainElementEndString);
						yourself.
						
	^ domainElementEnd
! !

!SPParser methodsFor: 'specific' stamp: 'AlexandreBergel 11/20/2012 09:49'!
parseFeatureModel: featureModelString
	| featureName fmFamiliarString fmFeatureModel |
	self assertBeginWithTag: featureModelString.
	
	featureName := self getIdFrom: featureModelString.

	fmFamiliarString := featureModelString
		copyFrom: (featureModelString indexOfSubCollection: 'FM(')
		to: featureModelString size.
	fmFeatureModel := FMASTBuilder new featureModel parse: fmFamiliarString.
	fmFeatureModel class == FMFeatureModel
		ifFalse: [ self error: 'Parsing error of the familiar feature model' ].
	^ SPFeatureModel new
		name: featureName;
		fmFeatureModel: fmFeatureModel;
		yourself! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:47'!
parseLine: line
 ! !

!SPParser methodsFor: 'private' stamp: 'AlexandreBergel 11/19/2012 15:50'!
parseLines: lines
	self assertContainsBeginStatement: lines.
	lines do: [ :line | self parseLine: line ].
	self assertContainsEndingStatement: lines! !
